<script src="./Script.js"></script>

<template>
  <div class="nt-settings-content">
    <div
      class="m-portlet m-portlet--head-sm s--portlet-collapse float-left w-100 position-relative"
      id="permissionDetail"
      v-if="isLoadedSuccess && isIssetStructure && listStructuresIssetPermission && listStructuresIssetPermission.length > 0"
    >
      <div class="m-portlet__head nt-background-footer" id="permissionTableHead">
        <div style="width: 100%; display: flex;">
          <div class="m-portlet__head-caption float-left" style="width: calc(100% - 30px)">
            <div class="m-portlet__head-title">
              <h5 class="nt-color-primary nt-head-title" style="margin:0px;">
                <i class="icon icon-branching"></i>&nbsp;
                Phân quyền người dùng
              </h5>
            </div>
          </div>
        </div>
      </div>
      <div class="nt-scroll-primary" style="overflow: auto;">
        <div class="m--padding-left-20 m--padding-right-20 m--padding-top-20">
          <a
            :href="ID_BASE_URL + '/team/' + currentTeamId + '/organizational-structure'"
            class="nt-button nt-button-secondary float-right"
          >
            <i class="icon icon-child_organization-01"></i>&nbsp;Cơ cấu tổ chức
          </a>
        </div>
        <div class="nt-lock-permission m--padding-20">
          <div id="nt-table-lock-left" class="nt-table-lock-left">
            <div class="nt-table-lock-left-content">
              <div class="nt-table-lock-line nt-table-lock-head" style="height:48px;">
                <span>Tên quyền</span>
              </div>
              <div class="nt-table-lock-line">
                <span></span>
              </div>
              <template v-for="(permission, index) in listPermission">
                <div
                  :key="index"
                  v-if="!permission.hidden"
                  :class="permission.parent === 0 ? 'nt-table-block-parent-line' : ''"
                  class="nt-table-lock-line"
                  :style="{background : permission.parent === 0 ? '#F4F5F9' : '', height: permission.parent === 0 ? '48px' : '40px'}"
                >
                  <div
                    class="nt-table-lock-content"
                    v-if="permission.parent === 0"
                    :class="permission.parent === 0 ? 'nt-table-lock-parent' : ''"
                  >
                    <div
                      class="m--header-collapse d-inline-flex"
                      @click="switchCollapseArrow($event, 'left', permission.id)"
                    >
                      <a class="float-left nt-button-collapse">
                        <i class="icon icon-up-arrow-1"></i>
                      </a>
                      <h5
                        data-toggle="collapse"
                        class="nt-collapse-header nt-color-primary float-left"
                        style="margin: 0px 0px 0px 10px; font-size:16px;"
                        href="javascript:;"
                      >{{permission.name}}</h5>
                    </div>
                  </div>
                  <div
                    class="nt-table-lock-content"
                    v-if="permission.parent !== 0"
                    :data-parent="permission.parent"
                  >{{permission.name}}</div>
                </div>
              </template>
            </div>
          </div>
          <div class="nt-table-lock nt-scroll-primary" id="table-lock-scroll">
            <table
              id="table-lock-scroll-content table-responsive nt-scroll-primary"
              class="table table-bordered nt-table-list nt-table-list-all"
            >
              <thead>
                <tr style="height:48px;">
                  <template v-for="(structure, index) in listStructuresIssetPermission">
                    <th v-if="!structure.hidden" :key="index">
                      <span
                        v-if="structure.has_children"
                        @click="switchCollapseArrow($event, 'top', structure.id)"
                        style="cursor: pointer"
                      >
                        <a class="nt-button-collapse">
                          <i class="icon icon-left-arrow"></i>
                        </a>
                        <span style="margin-left:10px;">{{structure.name}}</span>
                      </span>
                      <span v-else>
                        <span style="margin-left:10px;">{{structure.name}}</span>
                      </span>
                    </th>
                  </template>
                </tr>
              </thead>
              <tbody>
                <tr>
                  <template v-for="(structure, index) in listStructuresIssetPermission">
                    <td :key="index" v-if="!structure.hidden" class="text-center">
                      <label
                        v-if="structure.permissions.length <= 0"
                        class="m-checkbox m-checkbox--primary m--margin-bottom-15"
                        @click.prevent="checkAllPermission(structure)"
                      >
                        <input type="checkbox" value />
                        <span></span>
                      </label>
                      <label
                        v-else-if="structure.permissions.length > 0 && structure.permissions.length < countPermission"
                        class="m-checkbox nt-checkbox-minus-primary m--margin-bottom-15"
                        @click.prevent="minusAllPermission(structure)"
                      >
                        <input type="checkbox" checked="checked" />
                        <span></span>
                      </label>
                      <label
                        v-else
                        class="m-checkbox m-checkbox--primary m--margin-bottom-15"
                        @click.prevent="minusAllPermission(structure)"
                      >
                        <input type="checkbox" checked="checked" />
                        <span></span>
                      </label>
                    </td>
                  </template>
                </tr>
                <template v-for="(permission, indexA) in listPermission">
                  <tr
                    :key="indexA"
                    v-if="!permission.hidden"
                    :class="permission.parent === 0 ? 'nt-table-block-parent-line' : ''"
                    class="nt-table-lock-line"
                    :style="{background : permission.parent === 0 ? '#F4F5F9' : '', height: permission.parent === 0 ? '48px' : '40px'}"
                  >
                    <template v-for="(structure, indexB) in listStructuresIssetPermission">
                      <td :key="indexB" v-if="!structure.hidden" class="text-center">
                        <!--<template v-if="permission.parent === 0">-->
                        <!--<s-custom-select-->
                        <!--:data="listRules"-->
                        <!--:label="'name'"-->
                        <!--:index="'id'"-->
                        <!--:position_select="'status-' + permission.id + '-' + structure.id"-->
                        <!--:value.sync="structure.rules"-->
                        <!--:text="'trạng thái'"-->
                        <!--&gt;</s-custom-select>-->
                        <!--</template>-->
                        <template v-if="permission.parent == 0">
                          <label
                            class="m-checkbox m-checkbox--primary m--margin-bottom-15"
                            :class="{'nt-checkbox-minus-primary': structure.count_structure_permission_category[permission.current_id] && structure.count_structure_permission_category[permission.current_id] != 0 && structure.count_structure_permission_category[permission.current_id] != structure.count_permission_category[permission.current_id]}"
                            @change="checkPermissionParentCategory(structure, permission)"
                          >
                            <input
                              type="checkbox"
                              checked="checked"
                              v-model="structure.is_checked_parent[permission.current_id]"
                            />
                            <span></span>
                          </label>
                        </template>
                        <template v-if="permission.parent !== 0">
                          <label
                            class="m-checkbox m-checkbox--primary m--margin-bottom-15"
                            @change="checkPermission(structure, permission)"
                          >
                            <input
                              v-model="structure.permissions"
                              type="checkbox"
                              :value="permission.permission_id"
                            />
                            <span></span>
                          </label>
                        </template>
                      </td>
                    </template>
                  </tr>
                </template>
              </tbody>
            </table>
          </div>
        </div>
      </div>
      <div
        class="w-100 nt-background-footer d-inline-flex m--margin-top-5 justify-content-end"
        style="border-top : solid 1px #ebedf2; padding: 15px 20px;"
      >
        <button class="nt-button nt-button-secondary" @click.prevent="cancelPermission()">Hủy bỏ</button>
        <button
          class="nt-button nt-button-warning"
          :disabled="!isChange || isLoadingSavePermission"
          :class="!isChange || isLoadingSavePermission ? 'nt-button-disabled' : ''"
          @click.prevent="saveSetPermission()"
        >Lưu lại</button>
      </div>
      <div
        v-if="isLoadingSavePermission"
        class="nt-backdrop-loading position-absolute"
        style="top:0px; left:0px; width:100%; height:100%; background: rgba(255, 255, 255, 0.55); z-index:50"
      >
        <div
          class="m-loader m-loader--brand m-loader--lg position-absolute"
          style="width: 30px; height: 30px; display: inline-block; top:50%; left:50%; transform: translate(-50%, -50%)"
        ></div>
      </div>
      <div
        data-backdrop="static"
        data-keyboard="false"
        class="modal fade s--modal-confirm nt--modal-confirm"
        id="errorSetPermissionChildrenBiggerParent"
      >
        <div class="modal-dialog" style="max-width: 600px;">
          <div class="modal-content">
            <div style="margin: 11px;">
              <div>
                <button
                  type="button"
                  class="close modal-close"
                  @click="cancelPermission()"
                  data-dismiss="modal"
                  aria-label="Close"
                  style="top: 1em; right: 1em;"
                >
                  <span aria-hidden="true">
                    <i class="la la-times"></i>
                  </span>
                </button>
              </div>
              <div class="row">
                <div
                  class="popup-title"
                >QUYỀN CỦA PHÒNG BAN CẤP DƯỚI KHÔNG THỂ LỚN HƠN QUYỀN CỦA PHÒNG BAN CẤP TRÊN</div>
              </div>
              <div class="row popup-btn">
                <button
                  class="btn"
                  data-dismiss="modal"
                  @click="cancelPermission()"
                  aria-label="Close"
                >Đóng</button>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div
        data-backdrop="static"
        data-keyboard="false"
        class="modal fade s--modal-confirm nt--modal-confirm"
        id="errorSetPermissionForNotExist"
      >
        <div class="modal-dialog" style="max-width: 600px;">
          <div class="modal-content">
            <div style="margin: 11px;">
              <div>
                <button
                  type="button"
                  class="close modal-close"
                  @click="reloadPage()"
                  data-dismiss="modal"
                  aria-label="Close"
                  style="top: 1em; right: 1em;"
                >
                  <span aria-hidden="true">
                    <i class="la la-times"></i>
                  </span>
                </button>
              </div>
              <div class="row">
                <div class="popup-title">Dữ liệu đã bị thay đổi. Vui lòng tải lại trang</div>
              </div>
              <div class="row popup-btn">
                <button
                  class="btn"
                  data-dismiss="modal"
                  @click="reloadPage()"
                  aria-label="Close"
                >Đóng</button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div
      class="m-portlet m-portlet--head-sm s--portlet-collapse float-left w-100"
      v-else-if="isLoadedSuccess && (isNotIssetStructure || listStructuresIssetPermission && listStructuresIssetPermission.length <= 0)"
    >
      <div class="m-portlet__head" style="padding-left:0px;">
        <div class="nt-background-footer" style="width: 100%; display: flex; padding-left:20px">
          <div class="m-portlet__head-caption float-left" style="width: calc(100% - 30px)">
            <div class="m-portlet__head-title">
              <h5 class="nt-color-primary" style="margin:0px;">
                <i class="icon icon-branching"></i>&nbsp;
                Phân quyền người dùng
              </h5>
            </div>
          </div>
        </div>
      </div>
      <div class="nt-warning text-center" style="padding: 60px 0;">
        <div class="nt-warning-icon">
          <i class="la icon-warning nt-color-warning" style="font-size: 60px;"></i>
        </div>
        <h3
          class="nt-warning-title"
          style="font-size: 20px; color: #444F78;margin-top: 20px;"
        >Bạn chưa có phòng ban để phân quyền!</h3>
        <h4
          class="nt-warning-desc"
          style="font-size: 16px; color: #838CAB;font-weight: normal;"
        >Nhấn nút bên dưới để bắt đầu tạo tổ chức!</h4>
        <div style="display: flex; justify-content: center;margin-top: 20px;">
          <a
            class="nt-button nt-button-secondary"
            :href="ID_BASE_URL + '/team/' + currentTeamId + '/organizational-structure'"
            style="font-size: 15px;"
          >
            <i class="icon icon-child_organization-01"></i>
            Tạo cơ cấu tổ chức
          </a>
        </div>
      </div>
    </div>
    <div
      v-else
      class="m-loader m-loader--brand m-loader--lg"
      style="width: 30px; height: 30px; display: inline-block;"
    ></div>
  </div>
</template>